
# Test macros.
#
# $Id: macro.py,v 1.5 2001/11/11 08:42:08 djc Exp $

import unittest
import albatross
import albatross_test

class MacroCase(albatross_test.AlbatrossTestCase):
    template_dir = "macro"
    
    def check_macro_0arg(self):
        self.html_test("0arg.html", "content\n")

    def check_macro_0arg_dup(self):
        self.html_test("0arg-dup.html", "content\ncontent\n")

    def check_macro_1arg(self):
        self.html_test("1arg.html", "xxx argument xxx\n")

    def check_macro_2arg(self):
        self.html_test("2arg.html", "xxx first second xxx\n")

    def check_macro_unclosed(self):
        self.assertRaises(albatross.TemplateError, self.html_test, "unclosed.html", "(none)")

    def check_macro_unclosedarg(self):
        self.assertRaises(albatross.TemplateError, self.html_test, "unclosedarg.html", "(none)")

    def check_macro_missingarg(self):
        self.assertRaises(albatross.context.Error, self.html_test, "missingarg.html", "(none)")

    def check_macro_call1(self):
        self.html_test("call1.html", "xxx 5 xxx\nxxx 6 xxx\n")

class MacroSuite(unittest.TestSuite):
    test_list = (
        "check_macro_0arg",
        "check_macro_0arg_dup",
        "check_macro_1arg",
        "check_macro_2arg",
        "check_macro_unclosed",
        "check_macro_unclosedarg",
        "check_macro_missingarg",
        "check_macro_call1",
    )
    def __init__(self):
        unittest.TestSuite.__init__(self, map(MacroCase, self.test_list))

def suite():
    return MacroSuite()

if __name__ == '__main__':
    unittest.main(defaultTest='suite')
